// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 36 "src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"

  /// Build a parser object.
  Parser::Parser (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.YY_MOVE_OR_COPY< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.YY_MOVE_OR_COPY< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.YY_MOVE_OR_COPY< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.YY_MOVE_OR_COPY< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.copy< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.copy< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.copy< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.copy< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        yylhs.value.emplace< SizedType > ();
        break;

      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_config: // config
        yylhs.value.emplace< ast::Config * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        yylhs.value.emplace< ast::Offsetof * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        yylhs.value.emplace< ast::Sizeof * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions config probes "end of file"
#line 175 "src/parser.yy"
                                                { driver.root = std::make_unique<ast::Program>(yystack_[3].value.as < std::string > (), yystack_[2].value.as < ast::Config * > (), yystack_[1].value.as < ast::ProbeList * > ()); }
#line 1208 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 179 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1214 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct" "struct definition" c_definitions
#line 180 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1220 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "struct" "enum" c_definitions
#line 181 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1226 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 182 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::string(); }
#line 1232 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 7: // type: int_type
#line 186 "src/parser.yy"
                         { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1238 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 8: // type: "builtin type"
#line 187 "src/parser.yy"
                             {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"min_t", CreateMin(true)},
                        {"max_t", CreateMax(true)},
                        {"sum_t", CreateSum(true)},
                        {"count_t", CreateCount(true)},
                        {"avg_t", CreateAvg(true)},
                        {"stats_t", CreateStats(true)},
                        {"umin_t", CreateMin(false)},
                        {"umax_t", CreateMax(false)},
                        {"usum_t", CreateSum(false)},
                        {"ucount_t", CreateCount(false)},
                        {"uavg_t", CreateAvg(false)},
                        {"ustats_t", CreateStats(false)},
                        {"timestamp_t", CreateTimestamp()},
                        {"macaddr_t", CreateMacAddress()},
                        {"cgroup_path_t", CreateCgroupPath()},
                        {"strerror_t", CreateStrerror()},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1264 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 9: // type: "sized type" "[" "integer" "]"
#line 208 "src/parser.yy"
                                       {
                    if (yystack_[3].value.as < std::string > () == "str_t") {
                        yylhs.value.as < SizedType > () = CreateString(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "inet_t") {
                        yylhs.value.as < SizedType > () = CreateInet(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "buf_t") {
                        yylhs.value.as < SizedType > () = CreateBuffer(yystack_[1].value.as < int64_t > ());
                    }
                }
#line 1278 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 10: // type: int_type "[" "integer" "]"
#line 217 "src/parser.yy"
                                     {
                  yylhs.value.as < SizedType > () = CreateArray(yystack_[1].value.as < int64_t > (), yystack_[3].value.as < SizedType > ());
                }
#line 1286 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 11: // type: int_type "[" "]"
#line 220 "src/parser.yy"
                                 {
                  yylhs.value.as < SizedType > () = CreateArray(0, yystack_[2].value.as < SizedType > ());
                }
#line 1294 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 12: // type: pointer_type
#line 223 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1300 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 13: // type: struct_type
#line 224 "src/parser.yy"
                            { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1306 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 14: // int_type: "integer type"
#line 228 "src/parser.yy"
                         {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"bool", CreateBool()},
                        {"uint8", CreateUInt(8)},
                        {"uint16", CreateUInt(16)},
                        {"uint32", CreateUInt(32)},
                        {"uint64", CreateUInt(64)},
                        {"int8", CreateInt(8)},
                        {"int16", CreateInt(16)},
                        {"int32", CreateInt(32)},
                        {"int64", CreateInt(64)},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1325 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 15: // pointer_type: type "*"
#line 245 "src/parser.yy"
                         { yylhs.value.as < SizedType > () = CreatePointer(yystack_[1].value.as < SizedType > ()); }
#line 1331 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 16: // struct_type: "struct" "identifier"
#line 248 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = ast::ident_to_record(yystack_[0].value.as < std::string > ()); }
#line 1337 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 17: // config: "config" "=" config_block
#line 252 "src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = new ast::Config(yystack_[0].value.as < ast::StatementList * > ()); }
#line 1343 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 18: // config: %empty
#line 253 "src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = nullptr; }
#line 1349 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 19: // probes: probes probe
#line 257 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1355 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 20: // probes: probe
#line 258 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1361 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 21: // probe: attach_points pred block
#line 263 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1375 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 22: // probe: attach_points "end of file"
#line 273 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1389 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 23: // attach_points: attach_points "," attach_point
#line 285 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1395 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 24: // attach_points: attach_point
#line 286 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1401 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 25: // attach_point: attach_point_def
#line 290 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1407 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 26: // attach_point_def: attach_point_def ident
#line 294 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1413 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 27: // attach_point_def: attach_point_def "string"
#line 298 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1419 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 28: // attach_point_def: attach_point_def "path"
#line 299 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1425 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 29: // attach_point_def: attach_point_def "integer"
#line 300 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < int64_t > ()); }
#line 1431 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 30: // attach_point_def: attach_point_def ":"
#line 301 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1437 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 31: // attach_point_def: attach_point_def "."
#line 302 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1443 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 32: // attach_point_def: attach_point_def "+"
#line 303 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1449 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 33: // attach_point_def: attach_point_def "*"
#line 304 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1455 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 34: // attach_point_def: attach_point_def "["
#line 305 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1461 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 35: // attach_point_def: attach_point_def "]"
#line 306 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1467 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 36: // attach_point_def: attach_point_def param
#line 308 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1484 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 37: // attach_point_def: %empty
#line 320 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1490 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 38: // pred: "/" expr "end predicate"
#line 324 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1496 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 39: // pred: %empty
#line 325 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1502 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 40: // param: "positional parameter"
#line 330 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1518 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 41: // param: "$#"
#line 341 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1524 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 42: // block: "{" stmt_list "}"
#line 345 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1530 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 43: // config_block: "{" config_assign_stmt_list "}"
#line 348 "src/parser.yy"
                                                    { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1536 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 44: // stmt_list: expr_stmt ";" stmt_list
#line 355 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1542 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 45: // stmt_list: expr_stmt
#line 356 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1548 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 46: // stmt_list: block_stmt stmt_list
#line 360 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1554 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 47: // stmt_list: %empty
#line 361 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1560 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 48: // config_assign_stmt_list: config_assign_stmt ";" config_assign_stmt_list
#line 365 "src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1566 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 49: // config_assign_stmt_list: config_assign_stmt
#line 366 "src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1572 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 50: // block_stmt: loop_stmt
#line 370 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1578 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 51: // block_stmt: if_stmt
#line 371 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1584 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 52: // expr_stmt: expr
#line 375 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1590 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 53: // expr_stmt: jump_stmt
#line 376 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1596 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 54: // expr_stmt: assign_stmt
#line 381 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1602 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 55: // jump_stmt: "break"
#line 385 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1608 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 56: // jump_stmt: "continue"
#line 386 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1614 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 57: // jump_stmt: "return"
#line 387 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1620 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 58: // loop_stmt: "unroll" "(" int ")" block
#line 391 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1626 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 59: // loop_stmt: "unroll" "(" param ")" block
#line 392 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1632 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 60: // loop_stmt: "while" "(" expr ")" block
#line 393 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1638 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 61: // if_stmt: "if" "(" expr ")" block
#line 397 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1644 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 62: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 398 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1650 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 63: // block_or_if: block
#line 402 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1656 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 64: // block_or_if: if_stmt
#line 403 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1662 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 65: // config_assign_stmt: "identifier" "=" expr
#line 407 "src/parser.yy"
                                    { yylhs.value.as < ast::Statement * > () = new ast::AssignConfigVarStatement(yystack_[2].value.as < std::string > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1668 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 66: // assign_stmt: tuple_access_expr "=" expr
#line 411 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1677 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 67: // assign_stmt: map "=" expr
#line 415 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1683 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 68: // assign_stmt: var "=" expr
#line 416 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1689 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 69: // assign_stmt: map compound_op expr
#line 418 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1698 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 70: // assign_stmt: var compound_op expr
#line 423 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1707 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 71: // primary_expr: "identifier"
#line 430 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1713 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 72: // primary_expr: int
#line 431 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1719 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 73: // primary_expr: "string"
#line 432 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1725 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 74: // primary_expr: "stack_mode"
#line 433 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1731 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 75: // primary_expr: "builtin"
#line 434 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1737 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 76: // primary_expr: "call_builtin"
#line 435 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1743 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 77: // primary_expr: "(" expr ")"
#line 436 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1749 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 78: // primary_expr: param
#line 437 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1755 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 79: // primary_expr: map_or_var
#line 438 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1761 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 80: // primary_expr: "(" expr "," vargs ")"
#line 440 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1772 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 81: // postfix_expr: primary_expr
#line 449 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1778 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 82: // postfix_expr: postfix_expr "." ident
#line 451 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1784 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 83: // postfix_expr: postfix_expr "->" ident
#line 452 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1790 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 84: // postfix_expr: tuple_access_expr
#line 454 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1796 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 85: // postfix_expr: postfix_expr "[" expr "]"
#line 456 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1802 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 86: // postfix_expr: call
#line 457 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1808 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 87: // postfix_expr: sizeof_expr
#line 458 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Sizeof * > (); }
#line 1814 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 88: // postfix_expr: offsetof_expr
#line 459 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Offsetof * > (); }
#line 1820 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 89: // postfix_expr: map_or_var "++"
#line 460 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1826 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 90: // postfix_expr: map_or_var "--"
#line 461 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1832 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 91: // postfix_expr: "++" ident
#line 463 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1838 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 92: // postfix_expr: "--" ident
#line 464 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1844 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 93: // tuple_access_expr: postfix_expr "." "integer"
#line 469 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < int64_t > (), yystack_[0].location); }
#line 1850 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 94: // unary_expr: unary_op cast_expr
#line 475 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1856 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 95: // unary_expr: postfix_expr
#line 476 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1862 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 96: // unary_expr: "++" map_or_var
#line 477 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1868 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 97: // unary_expr: "--" map_or_var
#line 478 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1874 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 98: // unary_expr: ident "--"
#line 480 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1880 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 99: // unary_expr: ident "++"
#line 481 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1886 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 100: // unary_op: "*"
#line 485 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 1892 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 101: // unary_op: "~"
#line 486 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 1898 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 102: // unary_op: "!"
#line 487 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 1904 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 103: // unary_op: "-"
#line 488 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 1910 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 104: // expr: conditional_expr
#line 492 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1916 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 105: // conditional_expr: logical_or_expr
#line 496 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1922 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 106: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 497 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1928 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 107: // logical_or_expr: logical_and_expr
#line 502 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1934 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 108: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 503 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1940 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 109: // logical_and_expr: or_expr
#line 507 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1946 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 110: // logical_and_expr: logical_and_expr "&&" or_expr
#line 508 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1952 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 111: // or_expr: xor_expr
#line 512 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1958 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 112: // or_expr: or_expr "|" xor_expr
#line 513 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1964 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 113: // xor_expr: and_expr
#line 517 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1970 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 114: // xor_expr: xor_expr "^" and_expr
#line 518 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1976 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 115: // and_expr: equality_expr
#line 523 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1982 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 116: // and_expr: and_expr "&" equality_expr
#line 524 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1988 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 117: // equality_expr: relational_expr
#line 528 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1994 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 118: // equality_expr: equality_expr "==" relational_expr
#line 529 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2000 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 119: // equality_expr: equality_expr "!=" relational_expr
#line 530 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2006 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 120: // relational_expr: shift_expr
#line 534 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2012 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 121: // relational_expr: relational_expr "<=" shift_expr
#line 535 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2018 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 122: // relational_expr: relational_expr ">=" shift_expr
#line 536 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2024 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 123: // relational_expr: relational_expr "<" shift_expr
#line 537 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2030 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 124: // relational_expr: relational_expr ">" shift_expr
#line 538 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2036 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 125: // shift_expr: addi_expr
#line 542 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2042 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 126: // shift_expr: shift_expr "<<" addi_expr
#line 543 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2048 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 127: // shift_expr: shift_expr ">>" addi_expr
#line 544 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2054 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 128: // muli_expr: cast_expr
#line 548 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2060 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 129: // muli_expr: muli_expr "*" cast_expr
#line 549 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2066 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 130: // muli_expr: muli_expr "/" cast_expr
#line 550 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2072 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 131: // muli_expr: muli_expr "%" cast_expr
#line 551 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2078 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 132: // addi_expr: muli_expr
#line 555 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2084 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 133: // addi_expr: addi_expr "+" muli_expr
#line 556 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2090 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 134: // addi_expr: addi_expr "-" muli_expr
#line 557 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2096 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 135: // cast_expr: unary_expr
#line 561 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2102 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 136: // cast_expr: "(" type ")" cast_expr
#line 562 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < SizedType > (), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2108 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 137: // cast_expr: "(" "identifier" ")" cast_expr
#line 564 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[2].value.as < std::string > (), 0), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2114 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 138: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 565 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[3].value.as < std::string > (), 1), yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 2120 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 139: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 566 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[4].value.as < std::string > (), 2), yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 2126 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 140: // sizeof_expr: "sizeof" "(" type ")"
#line 570 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < SizedType > (), yylhs.location); }
#line 2132 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 141: // sizeof_expr: "sizeof" "(" expr ")"
#line 571 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 2138 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 142: // offsetof_expr: "offsetof" "(" struct_type "," ident ")"
#line 575 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < SizedType > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2144 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 143: // offsetof_expr: "offsetof" "(" expr "," ident ")"
#line 577 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2150 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 144: // int: "-" "integer"
#line 581 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((int64_t)(~(uint64_t)(yystack_[0].value.as < int64_t > ()) + 1), yylhs.location); }
#line 2156 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 145: // int: "integer"
#line 582 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < int64_t > (), yylhs.location); }
#line 2162 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 146: // ident: "identifier"
#line 586 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2168 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 147: // ident: "builtin"
#line 587 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2174 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 148: // ident: "call"
#line 588 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2180 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 149: // ident: "call_builtin"
#line 589 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2186 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 150: // ident: "stack_mode"
#line 590 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2192 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 151: // call: "call" "(" ")"
#line 594 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2198 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 152: // call: "call" "(" vargs ")"
#line 595 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2204 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 153: // call: "call_builtin" "(" ")"
#line 596 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2210 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 154: // call: "call_builtin" "(" vargs ")"
#line 597 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2216 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 155: // call: "identifier" "(" ")"
#line 598 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2222 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 156: // call: "identifier" "(" vargs ")"
#line 599 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2228 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 157: // call: "builtin" "(" ")"
#line 600 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2234 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 158: // call: "builtin" "(" vargs ")"
#line 601 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2240 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 159: // call: "stack_mode" "(" ")"
#line 602 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2246 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 160: // call: "stack_mode" "(" vargs ")"
#line 603 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2252 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 161: // map: "map"
#line 607 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2258 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 162: // map: "map" "[" vargs "]"
#line 608 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2264 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 163: // var: "variable"
#line 612 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2270 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 164: // map_or_var: var
#line 616 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 2276 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 165: // map_or_var: map
#line 617 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 2282 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 166: // vargs: vargs "," expr
#line 621 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2288 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 167: // vargs: expr
#line 622 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2294 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 168: // compound_op: "<<="
#line 626 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 2300 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 169: // compound_op: "&="
#line 627 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 2306 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 170: // compound_op: "|="
#line 628 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 2312 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 171: // compound_op: "^="
#line 629 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 2318 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 172: // compound_op: "/="
#line 630 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2324 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 173: // compound_op: "-="
#line 631 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2330 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 174: // compound_op: "%="
#line 632 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2336 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 175: // compound_op: "*="
#line 633 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2342 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 176: // compound_op: "+="
#line 634 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2348 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;

  case 177: // compound_op: ">>="
#line 635 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2354 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"
    break;


#line 2358 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -149;

  const short Parser::yytable_ninf_ = -151;

  const short
  Parser::yypact_[] =
  {
     -35,    12,   -35,    13,   -40,   -35,   -35,  -149,  -149,    32,
    -149,  -149,  -149,    17,    40,  -149,     7,  -149,    23,    -9,
    -149,  -149,  -149,  -149,  -149,   522,    57,  -149,  -149,  -149,
    -149,  -149,  -149,  -149,  -149,  -149,  -149,  -149,  -149,  -149,
    -149,  -149,  -149,  -149,  -149,    61,    83,   104,  -149,   176,
     108,    35,   108,  -149,  -149,  -149,   130,   138,    34,   148,
      55,    56,  -149,   112,  -149,  -149,    87,  -149,  -149,     8,
    -149,  -149,   522,   113,  -149,    10,   146,   135,   129,   149,
     201,    93,   214,   184,   -15,  -149,  -149,  -149,  -149,     0,
    -149,  -149,  -149,     6,    90,  -149,   522,  -149,    -9,   120,
    -149,  -149,   187,    19,     2,   190,  -149,  -149,   110,  -149,
    -149,  -149,  -149,  -149,   219,   262,   307,   350,   393,   436,
     522,   479,   522,   141,   117,  -149,  -149,   522,   522,   522,
     522,   522,   522,   522,   522,   522,   522,   522,   522,   522,
     522,   522,   522,   522,   522,   522,  -149,  -149,  -149,  -149,
     192,   198,   200,  -149,  -149,  -149,   215,    90,   228,  -149,
    -149,  -149,  -149,   221,  -149,   544,   574,  -149,  -149,  -149,
     169,   522,     4,   522,  -149,    -3,  -149,   522,    28,   246,
     251,   260,  -149,  -149,   114,  -149,   125,  -149,   131,  -149,
     133,    11,  -149,   165,   266,  -149,  -149,  -149,   272,   146,
     135,   129,   149,   201,    93,    93,   214,   214,   214,   214,
     -15,   -15,  -149,  -149,  -149,   184,   184,   522,     3,   522,
    -149,  -149,    90,   522,   522,  -149,  -149,  -149,  -149,  -149,
    -149,  -149,  -149,  -149,  -149,   522,   522,   522,   269,  -149,
     522,   280,  -149,  -149,   271,   178,  -149,  -149,   117,   117,
    -149,   522,  -149,  -149,  -149,  -149,  -149,  -149,   522,   281,
      35,   282,   289,   293,  -149,  -149,  -149,  -149,  -149,  -149,
    -149,  -149,   522,  -149,  -149,   294,   295,  -149,  -149,    57,
      57,    57,    57,  -149,  -149,  -149,   255,  -149,  -149,  -149,
       5,  -149,  -149,  -149
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       6,     0,     6,     0,    18,     6,     6,     3,     1,     0,
      37,     4,     5,     0,    37,    20,    39,    24,    25,     0,
      17,     2,    19,    22,    37,     0,     0,    30,    34,    35,
      41,    32,    33,    31,   147,   148,   149,   146,    28,    27,
      40,    29,   150,    36,    26,     0,     0,    49,    23,     0,
       0,   103,     0,   100,   102,   101,     0,     0,    75,   148,
      76,    71,    73,   161,   163,   145,    74,    78,    81,    95,
      84,   135,     0,     0,   104,   105,   107,   109,   111,   113,
     115,   117,   120,   132,   125,   128,    87,    88,    72,     0,
      86,   165,   164,    79,    47,    21,     0,    43,     0,     0,
      14,     8,     0,    71,     0,     7,    12,    13,     0,    91,
      96,   144,    92,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    94,    38,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,    98,    89,    90,
       0,     0,     0,    57,    56,    55,     0,    47,    45,    53,
      50,    51,    54,    84,    52,   165,   164,    65,    48,    16,
       0,     0,     0,     0,    15,     0,    77,     0,     0,     0,
       0,     0,   157,   167,     0,   151,     0,   153,     0,   155,
       0,     0,   159,     0,     0,    93,    82,    83,     0,   108,
     110,   112,   114,   116,   118,   119,   121,   122,   123,   124,
     126,   127,   129,   130,   131,   133,   134,     0,     0,     0,
      42,    46,    47,     0,     0,   168,   177,   176,   173,   175,
     172,   174,   169,   170,   171,     0,     0,     0,     0,   137,
       0,     0,   136,    11,     0,     0,   140,   141,     0,     0,
     158,     0,   152,   154,   156,   162,   160,    85,     0,     0,
       0,     0,     0,     0,    44,    66,    67,    69,    68,    70,
       9,   138,     0,    10,    80,     0,     0,   166,   106,     0,
       0,     0,     0,   139,   142,   143,    61,    59,    58,    60,
       0,    63,    64,    62
  };

  const short
  Parser::yypgoto_[] =
  {
    -149,  -149,   116,   193,  -149,  -149,   195,  -149,  -149,   297,
    -149,   288,  -149,  -149,   -16,   -12,  -149,  -148,   216,  -149,
    -149,  -149,  -149,    29,  -149,  -149,  -149,  -149,  -149,   -91,
    -149,  -149,   -24,    60,  -149,   185,   191,   199,   197,   203,
     115,    25,   118,   121,   -64,  -149,  -149,   124,   -18,  -149,
     -90,   -88,   106,   -67,   156
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     4,   104,   105,   106,   107,    10,    14,    15,
      16,    17,    18,    26,    67,    95,    20,   156,    46,   157,
     158,   159,   160,   161,   293,    47,   162,    68,    69,    70,
      71,    72,   183,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,   184,   235
  };

  const short
  Parser::yytable_[] =
  {
      44,    73,    43,   163,   165,   243,   166,    23,   125,   221,
      94,   144,   173,     8,   240,   122,     9,    30,     1,   255,
      24,   127,    19,   145,   251,   108,    27,   146,   119,   171,
      28,    29,   109,   148,   112,   128,     2,    30,   246,   147,
      21,   260,   174,   116,   241,   149,  -146,    13,    25,    31,
     186,   188,   190,   191,   193,   150,   123,   124,  -146,   172,
      45,  -147,    94,    32,   118,   119,   163,   165,   174,   166,
     164,    33,   167,  -147,   264,   244,    96,   212,   213,   214,
      40,    65,  -149,  -146,     5,     6,    34,    35,    36,    97,
     179,   181,    37,    38,  -149,  -146,   121,    39,   194,    49,
      40,    41,    42,   198,    30,   196,   197,   239,    98,   242,
     245,   135,   136,   111,  -150,   137,   138,    50,     7,   120,
     176,    11,    12,   177,   250,   126,  -150,   251,    51,    52,
      53,   163,   165,   164,   166,   252,    54,    55,   251,   114,
     150,   253,   151,   254,   251,   152,   251,   115,   153,   154,
     155,    56,    57,    58,    59,    60,   110,   117,   113,    61,
     206,   207,   208,   209,    62,    63,    64,    40,    65,    66,
     129,    34,    35,    36,   131,   256,   271,    37,   251,   130,
      34,    35,    36,    63,    64,    49,    37,    42,   274,   169,
      30,   251,   132,   259,   170,   263,    42,   175,   164,   265,
     266,   217,   261,    50,    34,    35,    36,   218,   283,   219,
      37,   267,   268,   269,    51,    52,    53,   133,   134,   195,
      42,   220,    54,    55,   141,   142,   143,   277,    49,    99,
     275,   276,   222,    30,   139,   140,   223,    56,    57,    58,
      59,    60,   100,   101,   102,   103,    50,   238,   204,   205,
      62,    63,    64,    40,    65,    66,   247,    51,    52,    53,
     210,   211,   215,   216,   248,    54,    55,   286,   287,   288,
     289,    49,    99,   249,   257,   258,    30,   270,   291,   273,
      56,    57,    58,    59,    60,   100,   101,   102,    61,    50,
     272,   279,   280,    62,    63,    64,    40,    65,    66,   281,
      51,    52,    53,   282,   284,   285,   290,   178,    54,    55,
     180,    22,    48,   199,   168,    99,    49,   182,   278,   292,
     200,    30,   237,    56,    57,    58,    59,    60,   202,   201,
       0,    61,     0,     0,    50,   203,    62,    63,    64,    40,
      65,    66,   262,     0,     0,    51,    52,    53,     0,     0,
       0,     0,     0,    54,    55,     0,     0,     0,     0,    49,
     185,     0,     0,     0,    30,     0,     0,     0,    56,    57,
      58,    59,    60,     0,     0,     0,    61,    50,     0,     0,
       0,    62,    63,    64,    40,    65,    66,     0,    51,    52,
      53,     0,     0,     0,     0,     0,    54,    55,     0,     0,
       0,     0,    49,   187,     0,     0,     0,    30,     0,     0,
       0,    56,    57,    58,    59,    60,     0,     0,     0,    61,
      50,     0,     0,     0,    62,    63,    64,    40,    65,    66,
       0,    51,    52,    53,     0,     0,     0,     0,     0,    54,
      55,     0,     0,     0,     0,    49,   189,     0,     0,     0,
      30,     0,     0,     0,    56,    57,    58,    59,    60,     0,
       0,     0,    61,    50,     0,     0,     0,    62,    63,    64,
      40,    65,    66,     0,    51,    52,    53,     0,     0,     0,
       0,     0,    54,    55,     0,     0,     0,     0,    49,   192,
       0,     0,     0,    30,     0,     0,     0,    56,    57,    58,
      59,    60,     0,     0,     0,    61,    50,     0,     0,     0,
      62,    63,    64,    40,    65,    66,     0,    51,    52,    53,
       0,     0,     0,     0,     0,    54,    55,     0,     0,     0,
       0,    49,     0,     0,     0,     0,    30,     0,     0,     0,
      56,    57,    58,    59,    60,     0,     0,     0,    61,    50,
       0,     0,     0,    62,    63,    64,    40,    65,    66,   224,
      51,    52,    53,     0,     0,     0,     0,     0,    54,    55,
       0,     0,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,    56,    57,    58,    59,    60,     0,   236,
       0,    61,     0,     0,     0,     0,    62,    63,    64,    40,
      65,    66,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234
  };

  const short
  Parser::yycheck_[] =
  {
      18,    25,    18,    94,    94,     8,    94,     0,    72,   157,
       5,    26,    10,     0,    10,     7,    56,    14,    53,     8,
      13,    11,     5,    38,    13,    49,     3,    27,     9,    10,
       7,     8,    50,    27,    52,    25,    71,    14,    10,    39,
       0,    38,    40,     9,    40,    39,    27,    15,    41,    26,
     117,   118,   119,   120,   121,    50,    48,    49,    39,    40,
      69,    27,     5,    40,     9,     9,   157,   157,    40,   157,
      94,    48,    96,    39,   222,    78,    15,   141,   142,   143,
      77,    78,    27,    27,    72,    73,    63,    64,    65,     6,
     114,   115,    69,    70,    39,    39,     9,    74,   122,     9,
      77,    78,    79,   127,    14,   123,   124,   171,     4,   173,
     177,    18,    19,    78,    27,    22,    23,    27,     2,     7,
      10,     5,     6,    13,    10,    12,    39,    13,    38,    39,
      40,   222,   222,   157,   222,    10,    46,    47,    13,     9,
      50,    10,    52,    10,    13,    55,    13,     9,    58,    59,
      60,    61,    62,    63,    64,    65,    50,     9,    52,    69,
     135,   136,   137,   138,    74,    75,    76,    77,    78,    79,
      24,    63,    64,    65,    45,    10,   240,    69,    13,    44,
      63,    64,    65,    75,    76,     9,    69,    79,    10,    69,
      14,    13,    43,   217,     7,   219,    79,     7,   222,   223,
     224,     9,   218,    27,    63,    64,    65,     9,   272,     9,
      69,   235,   236,   237,    38,    39,    40,    16,    17,    78,
      79,     6,    46,    47,    40,    41,    42,   251,     9,    53,
     248,   249,     4,    14,    20,    21,    15,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    27,    78,   133,   134,
      74,    75,    76,    77,    78,    79,    10,    38,    39,    40,
     139,   140,   144,   145,    13,    46,    47,   279,   280,   281,
     282,     9,    53,    13,     8,     3,    14,     8,   290,     8,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    27,
      10,    10,    10,    74,    75,    76,    77,    78,    79,    10,
      38,    39,    40,    10,    10,    10,    51,   114,    46,    47,
     115,    14,    24,   128,    98,    53,     9,    10,   258,   290,
     129,    14,   166,    61,    62,    63,    64,    65,   131,   130,
      -1,    69,    -1,    -1,    27,   132,    74,    75,    76,    77,
      78,    79,   218,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    27,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    79,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,
      -1,    -1,     9,    10,    -1,    -1,    -1,    14,    -1,    -1,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      27,    -1,    -1,    -1,    74,    75,    76,    77,    78,    79,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    -1,    -1,    -1,     9,    10,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    27,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    46,    47,    -1,    -1,    -1,    -1,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    27,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    79,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    27,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    15,
      38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    -1,    61,    62,    63,    64,    65,    -1,    15,
      -1,    69,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37
  };

  const unsigned char
  Parser::yystos_[] =
  {
       0,    53,    71,    81,    82,    72,    73,    82,     0,    56,
      87,    82,    82,    15,    88,    89,    90,    91,    92,     5,
      96,     0,    89,     0,    13,    41,    93,     3,     7,     8,
      14,    26,    40,    48,    63,    64,    65,    69,    70,    74,
      77,    78,    79,    94,   128,    69,    98,   105,    91,     9,
      27,    38,    39,    40,    46,    47,    61,    62,    63,    64,
      65,    69,    74,    75,    76,    78,    79,    94,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,     5,    95,    15,     6,     4,    53,
      66,    67,    68,    69,    83,    84,    85,    86,   112,   128,
     132,    78,   128,   132,     9,     9,     9,     9,     9,     9,
       7,     9,     7,    48,    49,   124,    12,    11,    25,    24,
      44,    45,    43,    16,    17,    18,    19,    22,    23,    20,
      21,    40,    41,    42,    26,    38,    27,    39,    27,    39,
      50,    52,    55,    58,    59,    60,    97,    99,   100,   101,
     102,   103,   106,   109,   112,   130,   131,   112,    98,    69,
       7,    10,    40,    10,    40,     7,    10,    13,    83,   112,
      86,   112,    10,   112,   133,    10,   133,    10,   133,    10,
     133,   133,    10,   133,   112,    78,   128,   128,   112,   115,
     116,   117,   118,   119,   120,   120,   121,   121,   121,   121,
     123,   123,   124,   124,   124,   122,   122,     9,     9,     9,
       6,    97,     4,    15,    15,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,   134,    15,   134,    78,   124,
      10,    40,   124,     8,    78,   133,    10,    10,    13,    13,
      10,    13,    10,    10,    10,     8,    10,     8,     3,   112,
      38,    94,   127,   112,    97,   112,   112,   112,   112,   112,
       8,   124,    10,     8,    10,   128,   128,   112,   113,    10,
      10,    10,    10,   124,    10,    10,    95,    95,    95,    95,
      51,    95,   103,   104
  };

  const unsigned char
  Parser::yyr1_[] =
  {
       0,    80,    81,    82,    82,    82,    82,    83,    83,    83,
      83,    83,    83,    83,    84,    85,    86,    87,    87,    88,
      88,    89,    89,    90,    90,    91,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    93,    93,
      94,    94,    95,    96,    97,    97,    97,    97,    98,    98,
      99,    99,   100,   100,   100,   101,   101,   101,   102,   102,
     102,   103,   103,   104,   104,   105,   106,   106,   106,   106,
     106,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   109,   110,   110,   110,   110,   110,   110,
     111,   111,   111,   111,   112,   113,   113,   114,   114,   115,
     115,   116,   116,   117,   117,   118,   118,   119,   119,   119,
     120,   120,   120,   120,   120,   121,   121,   121,   122,   122,
     122,   122,   123,   123,   123,   124,   124,   124,   124,   124,
     125,   125,   126,   126,   127,   127,   128,   128,   128,   128,
     128,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   130,   130,   131,   132,   132,   133,   133,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     4,     2,     3,     3,     0,     1,     1,     4,
       4,     3,     1,     1,     1,     2,     2,     3,     0,     2,
       1,     3,     2,     3,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     0,     3,     0,
       1,     1,     3,     3,     3,     1,     2,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     5,
       5,     5,     7,     1,     1,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       5,     1,     3,     3,     1,     4,     1,     1,     1,     2,
       2,     2,     2,     3,     2,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     5,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     1,     3,     3,     1,     4,     4,     5,     6,
       4,     4,     6,     6,     2,     1,     1,     1,     1,     1,
       1,     3,     4,     3,     4,     3,     4,     3,     4,     3,
       4,     1,     4,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"config\"", "\"for\"",
  "\"return\"", "\"continue\"", "\"break\"", "\"sizeof\"", "\"offsetof\"",
  "\"builtin\"", "\"call\"", "\"call_builtin\"", "\"integer type\"",
  "\"builtin type\"", "\"sized type\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "type", "int_type", "pointer_type", "struct_type", "config", "probes",
  "probe", "attach_points", "attach_point", "attach_point_def", "pred",
  "param", "block", "config_block", "stmt_list", "config_assign_stmt_list",
  "block_stmt", "expr_stmt", "jump_stmt", "loop_stmt", "if_stmt",
  "block_or_if", "config_assign_stmt", "assign_stmt", "primary_expr",
  "postfix_expr", "tuple_access_expr", "unary_expr", "unary_op", "expr",
  "conditional_expr", "logical_or_expr", "logical_and_expr", "or_expr",
  "xor_expr", "and_expr", "equality_expr", "relational_expr", "shift_expr",
  "muli_expr", "addi_expr", "cast_expr", "sizeof_expr", "offsetof_expr",
  "int", "ident", "call", "map", "var", "map_or_var", "vargs",
  "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   175,   175,   179,   180,   181,   182,   186,   187,   208,
     217,   220,   223,   224,   228,   245,   248,   252,   253,   257,
     258,   262,   272,   285,   286,   290,   294,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   320,   324,   325,
     330,   341,   345,   348,   355,   356,   360,   361,   365,   366,
     370,   371,   375,   376,   381,   385,   386,   387,   391,   392,
     393,   397,   398,   402,   403,   407,   410,   415,   416,   417,
     422,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   449,   451,   452,   454,   456,   457,   458,   459,   460,
     461,   463,   464,   469,   475,   476,   477,   478,   480,   481,
     485,   486,   487,   488,   492,   496,   497,   502,   503,   507,
     508,   512,   513,   517,   518,   523,   524,   528,   529,   530,
     534,   535,   536,   537,   538,   542,   543,   544,   548,   549,
     550,   551,   555,   556,   557,   561,   562,   564,   565,   566,
     570,   571,   575,   577,   581,   582,   586,   587,   588,   589,
     590,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   607,   608,   612,   616,   617,   621,   622,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 3112 "/builddir/build/BUILD/bpftrace-0.20.1/anolis-linux-build/parser.tab.cc"

#line 638 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
